
# Guido Project

The Guido Project is an open source project that encompasses a music notation format, a score rendering engine and various music score utilities. The [Guido Music Notation Format](https://guidodoc.grame.fr) is a general purpose formal language for representing score-level music in a platform-independent plain text and human readable way. The format comes with various software components for music score rendering and manipulation. The main of these components is the Guido engine, a library that can be embedded on different platforms and using different programming languages.

This part of the repository is dedicated to Guido Project Web site, which is intended to document the library, either from developer and contributor viewpoint.


### Building the Web site

The build process makes use of `make`. The site itself is based on [mkdocs](https://www.mkdocs.org/).
To install the required components type:
~~~~~~~~~~~~~~~~
$ make install
~~~~~~~~~~~~~~~~

The documentation embeds a external pages like those generated by doxygen from the source code. 
To embed all these components type:
~~~~~~~~~~~~~~~~
$ make all
~~~~~~~~~~~~~~~~


### Testing and generating

You can test the web site using the mkdoc embedded web server. This server also scan any change in the source directory and refresh the pages dynamically which is really convenient for the development process. To launch the server type:
~~~~~~~~~~~~~~~~
$ make serve
~~~~~~~~~~~~~~~~

When ready, you can generate the documentation web site. Type:
~~~~~~~~~~~~~~~~
$ make build
~~~~~~~~~~~~~~~~

