/*
  GUIDO Library
  Copyright (C) 2014-2019	Grame

  This Source Code Form is subject to the terms of the Mozilla Public
  License, v. 2.0. If a copy of the MPL was not distributed with this
  file, You can obtain one at http://mozilla.org/MPL/2.0/.

  Grame Research Laboratory, 11, cours de Verdun Gensoul 69002 Lyon - France
  research@grame.fr

*/

#include "TimesFont.h"

void TimesFont::initialize()
{
	fRefSize = kTimesFontSize;		// the font size used to compute the extends map
	fHeight	 = kTimesFontHeight;	// the static height value

	fExtends[0] = 0;
	fExtends[1] = 0;
	fExtends[2] = 0;
	fExtends[3] = 0;
	fExtends[4] = 0;
	fExtends[5] = 0;
	fExtends[6] = 0;
	fExtends[7] = 0;
	fExtends[8] = 0;
	fExtends[9] = 80;
	fExtends[10] = 0;
	fExtends[11] = 67;
	fExtends[12] = 0;
	fExtends[13] = 0;
	fExtends[14] = 0;
	fExtends[15] = 0;
	fExtends[16] = 0;
	fExtends[17] = 0;
	fExtends[18] = 0;
	fExtends[19] = 0;
	fExtends[20] = 0;
	fExtends[21] = 0;
	fExtends[22] = 0;
	fExtends[23] = 0;
	fExtends[24] = 0;
	fExtends[25] = 0;
	fExtends[26] = 0;
	fExtends[27] = 0;
	fExtends[28] = 0;
	fExtends[29] = 0;
	fExtends[30] = 0;
	fExtends[31] = 0;
	fExtends[32] = 50;
	fExtends[33] = 67;
	fExtends[34] = 82;
	fExtends[35] = 100;
	fExtends[36] = 100;
	fExtends[37] = 167;
	fExtends[38] = 156;
	fExtends[39] = 36;
	fExtends[40] = 67;
	fExtends[41] = 67;
	fExtends[42] = 100;
	fExtends[43] = 113;
	fExtends[44] = 50;
	fExtends[45] = 67;
	fExtends[46] = 50;
	fExtends[47] = 56;
	fExtends[48] = 100;
	fExtends[49] = 100;
	fExtends[50] = 100;
	fExtends[51] = 100;
	fExtends[52] = 100;
	fExtends[53] = 100;
	fExtends[54] = 100;
	fExtends[55] = 100;
	fExtends[56] = 100;
	fExtends[57] = 100;
	fExtends[58] = 56;
	fExtends[59] = 56;
	fExtends[60] = 113;
	fExtends[61] = 113;
	fExtends[62] = 113;
	fExtends[63] = 89;
	fExtends[64] = 184;
	fExtends[65] = 144;
	fExtends[66] = 133;
	fExtends[67] = 133;
	fExtends[68] = 144;
	fExtends[69] = 122;
	fExtends[70] = 111;
	fExtends[71] = 144;
	fExtends[72] = 144;
	fExtends[73] = 67;
	fExtends[74] = 78;
	fExtends[75] = 144;
	fExtends[76] = 122;
	fExtends[77] = 178;
	fExtends[78] = 144;
	fExtends[79] = 144;
	fExtends[80] = 111;
	fExtends[81] = 144;
	fExtends[82] = 133;
	fExtends[83] = 111;
	fExtends[84] = 122;
	fExtends[85] = 144;
	fExtends[86] = 144;
	fExtends[87] = 189;
	fExtends[88] = 144;
	fExtends[89] = 144;
	fExtends[90] = 122;
	fExtends[91] = 67;
	fExtends[92] = 56;
	fExtends[93] = 67;
	fExtends[94] = 94;
	fExtends[95] = 100;
	fExtends[96] = 67;
	fExtends[97] = 89;
	fExtends[98] = 100;
	fExtends[99] = 89;
	fExtends[100] = 100;
	fExtends[101] = 89;
	fExtends[102] = 67;
	fExtends[103] = 100;
	fExtends[104] = 100;
	fExtends[105] = 56;
	fExtends[106] = 56;
	fExtends[107] = 100;
	fExtends[108] = 56;
	fExtends[109] = 156;
	fExtends[110] = 100;
	fExtends[111] = 100;
	fExtends[112] = 100;
	fExtends[113] = 100;
	fExtends[114] = 67;
	fExtends[115] = 78;
	fExtends[116] = 56;
	fExtends[117] = 100;
	fExtends[118] = 100;
	fExtends[119] = 144;
	fExtends[120] = 100;
	fExtends[121] = 100;
	fExtends[122] = 89;
	fExtends[123] = 96;
	fExtends[124] = 40;
	fExtends[125] = 96;
	fExtends[126] = 108;
	fExtends[127] = 100;
	fExtends[128] = 0;
	fExtends[129] = 0;
	fExtends[130] = 0;
	fExtends[131] = 0;
	fExtends[132] = 0;
	fExtends[133] = 0;
	fExtends[134] = 0;
	fExtends[135] = 0;
	fExtends[136] = 0;
	fExtends[137] = 0;
	fExtends[138] = 0;
	fExtends[139] = 0;
	fExtends[140] = 0;
	fExtends[141] = 0;
	fExtends[142] = 0;
	fExtends[143] = 0;
	fExtends[144] = 0;
	fExtends[145] = 0;
	fExtends[146] = 0;
	fExtends[147] = 0;
	fExtends[148] = 0;
	fExtends[149] = 0;
	fExtends[150] = 0;
	fExtends[151] = 0;
	fExtends[152] = 0;
	fExtends[153] = 0;
	fExtends[154] = 0;
	fExtends[155] = 0;
	fExtends[156] = 0;
	fExtends[157] = 0;
	fExtends[158] = 0;
	fExtends[159] = 0;
	fExtends[160] = 50;
	fExtends[161] = 67;
	fExtends[162] = 100;
	fExtends[163] = 100;
	fExtends[164] = 100;
	fExtends[165] = 100;
	fExtends[166] = 40;
	fExtends[167] = 100;
	fExtends[168] = 67;
	fExtends[169] = 152;
	fExtends[170] = 55;
	fExtends[171] = 100;
	fExtends[172] = 113;
	fExtends[173] = 0;
	fExtends[174] = 152;
	fExtends[175] = 67;
	fExtends[176] = 80;
	fExtends[177] = 110;
	fExtends[178] = 60;
	fExtends[179] = 60;
	fExtends[180] = 67;
	fExtends[181] = 115;
	fExtends[182] = 91;
	fExtends[183] = 50;
	fExtends[184] = 67;
	fExtends[185] = 60;
	fExtends[186] = 62;
	fExtends[187] = 100;
	fExtends[188] = 150;
	fExtends[189] = 150;
	fExtends[190] = 150;
	fExtends[191] = 89;
	fExtends[192] = 144;
	fExtends[193] = 144;
	fExtends[194] = 144;
	fExtends[195] = 144;
	fExtends[196] = 144;
	fExtends[197] = 144;
	fExtends[198] = 178;
	fExtends[199] = 133;
	fExtends[200] = 122;
	fExtends[201] = 122;
	fExtends[202] = 122;
	fExtends[203] = 122;
	fExtends[204] = 67;
	fExtends[205] = 67;
	fExtends[206] = 67;
	fExtends[207] = 67;
	fExtends[208] = 144;
	fExtends[209] = 144;
	fExtends[210] = 144;
	fExtends[211] = 144;
	fExtends[212] = 144;
	fExtends[213] = 144;
	fExtends[214] = 144;
	fExtends[215] = 113;
	fExtends[216] = 144;
	fExtends[217] = 144;
	fExtends[218] = 144;
	fExtends[219] = 144;
	fExtends[220] = 144;
	fExtends[221] = 144;
	fExtends[222] = 111;
	fExtends[223] = 100;
	fExtends[224] = 89;
	fExtends[225] = 89;
	fExtends[226] = 89;
	fExtends[227] = 89;
	fExtends[228] = 89;
	fExtends[229] = 89;
	fExtends[230] = 133;
	fExtends[231] = 89;
	fExtends[232] = 89;
	fExtends[233] = 89;
	fExtends[234] = 89;
	fExtends[235] = 89;
	fExtends[236] = 56;
	fExtends[237] = 56;
	fExtends[238] = 56;
	fExtends[239] = 56;
	fExtends[240] = 100;
	fExtends[241] = 100;
	fExtends[242] = 100;
	fExtends[243] = 100;
	fExtends[244] = 100;
	fExtends[245] = 100;
	fExtends[246] = 100;
	fExtends[247] = 110;
	fExtends[248] = 100;
	fExtends[249] = 100;
	fExtends[250] = 100;
	fExtends[251] = 100;
	fExtends[252] = 100;
	fExtends[253] = 100;
	fExtends[254] = 100;
	fExtends[255] = 100;
	fExtends[256] = 144;
}

